<?php
// oai-server es uploader kozos funkciok
// adatbaziskezeles kozos resze, xml gyartast segito rutinok, es egyeb aprosagok
require_once("oaidb.php");
require_once("parameters_inc.php");

function ISO8601Date($timestamp = "x") {
  if ($timestamp == "x") {
    $timestamp = time();
  }
  return gmdate("Y-m-d", $timestamp) . "T" . gmdate("H:i:s", $timestamp) . "Z";
}

function return_bytes($val) {
  $val = trim($val);
  $last = strtolower($val{strlen($val)-1});
  switch($last) {
    // The 'G' modifier is available since PHP 5.1.0
    case 'g':
      $val *= 1024;
    case 'm':
      $val *= 1024;
    case 'k':
      $val *= 1024;
  }
  return $val;
}

// getRecords
// beolvas mindent a paramterknt adott $repository adatbazisleiroval cimzett db-bol,
// s felpti a memriban a repositoryt
// deprecated
function getRecords($repository) {
  $db = new transdb($repository["type"], $repository["host"], $repository["user"], $repository["password"], $repository["database"]);
  $db->ErrorReporting($repository["warn"]);
  $sql = $db->selectall($repository["table"]);
  $records = array();
  foreach($sql as $zendfix => $rows) {
    ///$records[$rows["identifier"]][$rows["metadataprefix"]] = $rows;
    $records[$rows["id"]][$rows["metadataprefix"]]["old_id"] = $db->unescapestr($rows["old_id"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["sett"] = $db->unescapestr($rows["sett"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["created"] = $db->unescapedate($rows["created"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["modified"] = $db->unescapedate($rows["modified"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["deleted"] = $db->unescapedate($rows["deleted"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["xml"] = $db->unescapestr($rows["xml"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["harvestable"] = $db->unescapestr($rows["harvestable"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["id"] = $db->unescapestr($rows["id"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["root_name"] = $db->unescapestr($rows["root_name"]);
    $records[$rows["id"]][$rows["metadataprefix"]]["root_namespace"] = $db->unescapestr($rows["root_namespace"]);
  }
  $db->SQL_disconnect();
  return $records;
}
// metadataprefix -> root_name transition
function getRecordsNew($repository, $byexternal = FALSE, $disconnect = TRUE) {
  global $maxid;
  $maxid = 0;

  $db = new transdb($repository["type"], $repository["host"], $repository["user"], $repository["password"], $repository["database"]);
  $db->ErrorReporting($repository["warn"]);
  if (($sql = $db->selectall($repository["table"])) === FALSE) {
    return FALSE;
  }
  $records = array();
  foreach($sql as $zendfix => $rows) {
    ///$records[$rows["identifier"]][$rows["root_name"]] = $rows;
    //$records[$rows["id"]][$rows["root_name"]]["old_id"] = $db->unescapestr($rows["old_id"]);
    $rows["id"] = $db->unescapestr($rows["id"]);
    $rows["root_name"] = $db->unescapestr($rows["root_name"]);
    $rows["externalid"] = $db->unescapestr($rows["externalid"]);
    // TODO:dirty hacking - $maxid global
    if ($rows["id"] > $maxid) {
      $maxid = $rows["id"];
    }
    if ($byexternal) {
      $key = $rows["externalid"];
    } else {
      $key = $rows["id"];
    }
    if ($key != "") {
      $records[$key][$rows["root_name"]]["sett"] = $db->unescapestr($rows["sett"]);
      $records[$key][$rows["root_name"]]["created"] = $db->unescapedate($rows["created"]);
      $records[$key][$rows["root_name"]]["modified"] = $db->unescapedate($rows["modified"]);
      $records[$key][$rows["root_name"]]["deleted"] = $db->unescapedate($rows["deleted"]);
      $records[$key][$rows["root_name"]]["xml"] = $db->unescapestr($rows["xml"]);
      $records[$key][$rows["root_name"]]["harvestable"] = $db->unescapestr($rows["harvestable"]);
      $records[$key][$rows["root_name"]]["id"] = $rows["id"];
      $records[$key][$rows["root_name"]]["root_name"] = $rows["root_name"];
      $records[$key][$rows["root_name"]]["root_namespace"] = $db->unescapestr($rows["root_namespace"]);
      $records[$key][$rows["root_name"]]["externalid"] = $rows["externalid"];
    } elseif (!$byexternal) {
      #trigger_error('bug in GetRecordsNew', E_USER_WARNING);
    }
  }
  if ($disconnect) {
    $db->SQL_disconnect();
  }
  return $records;
}

// usage example:
// print XMLtag("request", array("verb" => "ListRecords", "metadataPrefix" => "nda_bibliographic"), "http://perl.oai.ht4/cgi-bin/oai.pl");
function XMLtagStart($tag, $qualifiers = NULL, $data = NULL) {
  $s = sprintf("<%s", $tag);
  if ($qualifiers !== NULL) {
    foreach($qualifiers as $key => $value) {
      $s .= sprintf(" %s=\"%s\"", $key, $value);
    }
  }
  $s .= sprintf(">");
  return $s;
}
function XMLtagEnd($tag, $qualifiers = NULL, $data = NULL) {
  return sprintf("</%s>\n", $tag);
}
function XMLtag($tag, $qualifiers = NULL, $data = NULL) {
  return sprintf("%s%s%s", XMLtagStart($tag, $qualifiers, $data), $data, XMLtagEnd($tag, $qualifiers, $data));
}

function ExplodeID($id) {
  return preg_replace("/^oai:[^:]+:/", "", $id);
}

function ScriptURL() {
  #return "http" . ($ENV{'HTTPS'} ? "s" : "") . "://" . $ENV{'HTTP_HOST'} . $ENV{'SCRIPT_NAME'};
}

function WriteRecord(&$db, $table, $record) {
  return $db->insert($table, array(
    "id" => $db->escapestr($record["id"]),
    "sett" => $db->escapestr($record["sett"]),
    "created" => $db->escapedate($record["created"]),
    "modified" => $db->escapedate($record["modified"]),
    "deleted" => $db->escapedate($record["deleted"]),
    "xml" => $db->escapestr($record["xml"]),
    "harvestable" => $db->escapestr($record["harvestable"]),
    "root_name" => $db->escapestr($record["root_name"]),
    "root_namespace" => $db->escapestr($record["root_namespace"])));
}

function triggerHarvester($schemaList = Array()) {
  global $config, $triggerHarvesterInterval;

  $FNchangeReport = "changeReport.xml";
  if (! $dom = domxml_open_file($FNchangeReport)) {
    $lastChangeReport = 0;
  } else {
    $lastChangeReport = getSubelementContent($dom, "lastChangeReport");
  }
  if (is_numeric($lastChangeReport) && ($lastChangeReport <= time()) && ($lastChangeReport > time() - $triggerHarvesterInterval)) {
    return TRUE;
  }

  if (array_key_exists("modificationReport.url", $config) && strlen($config["modificationReport.url"]) > 0) {
    $f = fopen($FNchangeReport, "w");
    fwrite($f, "<lastChangeReport>" . time() . "</lastChangeReport>\n");
    fclose($f);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_MUTE, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	if($config["modificationReport.mode"] == "GET") {
      curl_setopt($ch, CURLOPT_URL, $config["modificationReport.url"] . '?' . $config["modificationReport.identifierParamName"] . '=' . rawurlencode($config["repositoryId"]) . '&' . $config["modificationReport.schemaListParamName"] . '=' . join(',', $schemaList));
	} else {
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $config["modificationReport.identifierParamName"] . '=' . rawurlencode($config["repositoryId"]) . '&' . $config["modificationReport.schemaListParamName"] . '=' . join(',', $schemaList));
      curl_setopt($ch, CURLOPT_URL, $config["modificationReport.url"]);
    }
    $result = curl_exec($ch);
    curl_close($ch);
  }
}

function isHarvestable($xml) {
  if (preg_match("#<[^>]*source/?>#i", $xml)) {
    if (preg_match("#<[^>]*source>[^<]*(http|ftp)s?://.*\.#i", $xml)) {
      return TRUE;
    } else {
      return FALSE;
    }
  }
  return TRUE;
}

function ynHarvestable($xml) {
  return (isHarvestable($xml) ? "y" : "n");
}

?>
