<?php
if (version_compare(PHP_VERSION, '5', '>='))
  require_once('domxml-php4-to-php5.php'); //Load the PHP5 converter
// .xml configuracio beolvaso (es a beolvasast segito) rutinok
// oai.php hivja

// az xml formatumu configuracios file
$XMLconfigfile = "Repository.xml";


// valtozasjelentes minimum ilyen idokozonkent tortenik (sec)
$triggerHarvesterInterval = 3600 * 12;



// a betoltes modja - nem mukodik (?)
$mode = 0; // 0 = minden alkalommal a teljes allomany kerul konvertalasra. ha valamely azonositoju rekord ebben nem szerepel,
           // torolt statuszt kap a repositoryban.
           // 1 = csak a valtozasok illetve az uj rekordok kerulnek beolvasasra. ekkor nem mukodik a torles.

// TODO:DC sema adatok - hacking, nem hozzanyulni!
// DC sema mar nincs hasznalatban
$oai_dc_semanev = "oai_dc";
$oai_dc_format = "dc";
$oai_dc_format_namespace = "http://purl.org/dc/elements/1.1/";
$oai_dc_xsd = "http://www.openarchives.org/OAI/2.0/oai_dc.xsd";
$oai_dc_namespace = "http://www.openarchives.org/OAI/2.0/oai_dc/";



if (!function_exists('getSubelementContent')) { 
  function getSubelementContent($DomElement, $tagname, $num = 0) {
    if ($DomElement !== NULL) {
      $x = $DomElement->get_elements_by_tagname($tagname);
      if (count($x) > $num) {
        return $x[$num]->get_content();
      }
      return NULL;
    }
  }
}

if (!function_exists('getConnectIPs')) { 
  function getConnectIPs($dom, $tagname) {
    $allow = array();
    $domallow = $dom->get_elements_by_tagname($tagname);
    if (array_key_exists(0, $domallow)) {
      $domHCip = $domallow[0]->child_nodes();
      foreach($domHCip as $zendfix => $value) {
        if ($value->tagname === "ip") {
          $allow[$value->get_content()] = $value->get_content();
        }
      }
    }
    return $allow;
  }
}

// config, repository, metadataFormats, revmetadataFormats hashref-ek eloallitasa

if (! $dom = domxml_open_file($XMLconfigfile)) {
  print "Hiba a konfiguracio betoltese kozben( " . $XMLconfigfile . " )\n";
  exit;
}
$domsettings = $dom->get_elements_by_tagname("settings");
$config["resumptionSize"] = getSubelementContent($domsettings[0], "resumptionSize");
$config["resumptionExpirationHours"] = getSubelementContent($domsettings[0], "resumptionExpirationHours");

$domidentification = $dom->get_elements_by_tagname("identification");
$config["repositoryName"] = getSubelementContent($domidentification[0], "repositoryName");
$config["repositoryId"] = getSubelementContent($domidentification[0], "repositoryId");
$config["baseURL"] = getSubelementContent($domidentification[0], "baseURL");
$config["protocolVersion"] = getSubelementContent($domidentification[0], "protocolVersion");
$config["deletedRecord"] = getSubelementContent($domidentification[0], "deletedRecord");
$config["adminEmail"] = getSubelementContent($domidentification[0], "adminEmail");
$i = 0;
$config["friends"] = array();
while ($tmp = getSubelementContent($domidentification[0], "friends", $i)) {
  $config["friends"][] = $tmp;
  $i++;
}

$dommodificationReport = $dom->get_elements_by_tagname("modificationReport");
$config["modificationReport.url"] = getSubelementContent($dommodificationReport[0], "url");
$config["modificationReport.identifierParamName"] = getSubelementContent($dommodificationReport[0], "identifierParamName");
$config["modificationReport.schemaListParamName"] = getSubelementContent($dommodificationReport[0], "schemaListParamName");
$config["modificationReport.mode"] = getSubelementContent($dommodificationReport[0], "mode");

$dommanager = $dom->get_elements_by_tagname("manager");
for ($i = 0; $i < count($dommanager); $i++) {
  $manager[getSubelementContent($dommanager[$i], "user")] = getSubelementContent($dommanager[$i], "passwordHash");
}

$domdatabase = $dom->get_elements_by_tagname("database");
$repository["type"] = getSubelementContent($domdatabase[0], "type");
$repository["host"] = getSubelementContent($domdatabase[0], "host");
$repository["user"] = getSubelementContent($domdatabase[0], "username");
$repository["password"] = getSubelementContent($domdatabase[0], "password");
$repository["database"] = getSubelementContent($domdatabase[0], "database");
$repository["table"] = getSubelementContent($domdatabase[0], "table");
if (getSubelementContent($domdatabase[0], "warn") == "1") {
  $repository["warn"] = 1;
} else {
  $repository["warn"] = 0;
}
// TODO:HACK (?)
if ($repository["type"] === "csv") {
  $repository["database"] = $repository["table"];
}

$dommetadataFormats = $dom->get_elements_by_tagname("metadataFormats");
$domFormats = $dommetadataFormats[0]->child_nodes();
$metadataFormats = array();
foreach($domFormats as $zendfix => $value) {
  //var_dump($value, $value->type, $value->tagname);
  if ($value->tagname === "format") {
    $format_name = $value->get_attribute("name");
    $rootElementName = getSubelementContent($value, "rootElementName");

    $domcsvmap = $value->child_nodes();
    $map = array();
    $dcmap = array();
    $x = array();
    $y = array();
    foreach($domcsvmap as $zendfix2 => $csvmap) {
      if ($csvmap->tagname === "csvmap") {
        $_column = $csvmap->get_attribute("column");
        $_tag = $csvmap->get_attribute("tag");
        $_attr = $csvmap->get_attribute("attribute");
        $map[$_column][0] = $_tag;
        $map[$_column][1] = $_attr;
        if (! isset($x[$_tag][$_attr])) {
          $x[$_tag][$_attr] = 0;
        }
        $map[$_column][2] = $x[$_tag][$_attr];
        $x[$_tag][$_attr]++;

        $dcmap[$_column][0] = $_tag;
        if (! isset($y[$_tag])) {
          $y[$_tag] = 0;
        }
        $dcmap[$_column][1] = $y[$_tag];
        $y[$_tag]++;
      }
    }
    $metadataFormats[$format_name]["map"] = $map;
    $metadataFormats[$format_name]["dcmap"] = $dcmap;
    $revmetadataFormats[$rootElementName]["map"] = $map;
    $revmetadataFormats[$rootElementName]["dcmap"] = $dcmap;
    // a betltend llomnyban az rtkek elvlasztshoz hasznlt szepartor
    $metadataFormats[$format_name]["csvseparator"] = getSubelementContent($value, "csvseparator");
    $revmetadataFormats[$rootElementName]["csvseparator"] = getSubelementContent($value, "csvseparator");

    // metadata format for format.name -> rootElementName conversion
    $metadataFormats[$format_name]["format.name"] = $format_name;
    $metadataFormats[$format_name]["rootElementName"] = $rootElementName;
    $metadataFormats[$format_name]["schema"] = getSubelementContent($value, "schema");
    $metadataFormats[$format_name]["namespace"] = getSubelementContent($value, "namespace");
    // reverse metadata format for rootElementName -> format.name conversion
    $revmetadataFormats[$rootElementName]["format.name"] = $format_name;
    $revmetadataFormats[$rootElementName]["rootElementName"] = $rootElementName;
    $revmetadataFormats[$rootElementName]["schema"] = getSubelementContent($value, "schema");
    $revmetadataFormats[$rootElementName]["namespace"] = getSubelementContent($value, "namespace");
  }
}
//var_dump($metadataFormats);

$allowHarvesterConnect = getConnectIPs($dom, "allowHarvesterConnect");
$allowManagerConnect = getConnectIPs($dom, "allowManagerConnect");
//var_dump($allowHarvesterConnect, $allowManagerConnect);

foreach($config as $key => $value) {
  if ($value === NULL) {
    unset($config[$key]);
  }
}
//var_dump("<pre>", $config, $repository, "</pre>");

?>
