<?php
if (version_compare(PHP_VERSION, '5', '>='))
  require_once('domxml-php4-to-php5.php'); //Load the PHP5 converter
// kulso (tsv) adatok feltoltese - a tenyleges munka itt tortenik
require("parameters_inc.php");
require("oaicommon.php");
require_once("oaidb.php");

function PrintHeader() {
  print "<html><head><title>File feltlts</title></head><body>\n";
}

function PrintForm() {
  global $metadataFormats;

  print '<center>';
  print '<h3>php filefeltlts</h3>';
  print '<table border=0 cellpadding=5 cellspacing=0>';
  print '<form enctype="multipart/form-data" action="' . $_SERVER['PHP_SELF'] . '" method="POST">';
  print '<input type="hidden" name="MAX_FILE_SIZE" value="' . return_bytes(ini_get("post_max_size")) . '" />';
  print '<tr><td align="right">File feltltse:</td><td><input name="userfile" type="file" size="50" /></td></tr>';
  print '<tr><td align="right">Az albbi smba:</td><td><select name="schema">';
  foreach ($metadataFormats as $key => $value) {
    if ($key !== "oai_dc") {
      print '<option ';
      if (isset($_REQUEST["schema"]) && ($value["rootElementName"] == $_REQUEST["schema"])) {
        print 'selected="selected"';
      }
      print ' value="' . $value["rootElementName"] . '">' . $key . '</option>';
    }
  }
  print '</select></td></tr>';
  print '<tr><td></td><td><input name="csvheader" type="checkbox" id="csvheader" value="0" ' .
    (isset($_REQUEST["csvheader"]) ? "checked" : "") . '">';
  print 'a csv fjl fejlcet hasznl</input></td></tr>';
  print '<tr><td colspan=2 align="center"><hr noshade size=1>';
  print '<input type="submit" value="Feltlt" />';
  print '</td></tr>';
  print '</form></table>';
}

function PrintFooter() {
  print "</body></html>\n";
}

// oai_dc xml gyartasa
function generateXML_oai_dc($xml, $dc_schema = NULL, $dc_xsd = "http://www.openarchives.org/OAI/2.0/oai_dc.xsd", $dc_namespace = "http://www.openarchives.org/OAI/2.0/oai_dc/", $dc_schema_format = "dc") {
  global $oai_dc_format_namespace;
  global $revmetadataFormats;
  //var_dump("<pre>", $xml, "</pre>");
  $dc_schema = $revmetadataFormats[$dc_schema_format]["format.name"];
  //if ($dc_schema === NULL) {
  //  $dc_schema = "oai_dc";
  //}
  $str = XMLtagStart($dc_schema . ":" . $dc_schema_format, array(
    "xmlns:" . $dc_schema => $dc_namespace,
    "xsi:schemaLocation" => $dc_namespace . " " . $dc_xsd,
    "xmlns:" . $dc_schema_format => $oai_dc_format_namespace,
    "xmlns" => "http://www.openarchives.org/OAI/2.0/",
    "xmlns:xsi" => "http://www.w3.org/2001/XMLSchema-instance"));
  while (list($kulcs, $ertek) = each($xml)) {
    while (list($key, $val) = each($xml[$kulcs])) {
      for ($i = 0; $i < sizeof($xml[$kulcs][$key]); $i++) {
        if (strlen(trim($xml[$kulcs][$key][$i])) != 0) {
          if (($kulcs != $key) && ($key !== "")) {
            $str .= XMLtag($dc_schema_format . ":" . $kulcs, array("qualifier" => $key), htmlspecialchars($xml[$kulcs][$key][$i]));
          } else {
            $str .= XMLtag($dc_schema_format . ":" . $kulcs, NULL, htmlspecialchars($xml[$kulcs][$key][$i]));
          }
        }
      }
    }
  }
  $str .= XMLtagEnd($dc_schema . ":" . $dc_schema_format);
  //return base64_encode(gzcompress($str));
  return $str;
}

// generateXML
// a kapott paramterek alapjn felpti a DC kompatibilis XML llomnyt
function generateXML($xml, $betoltendo_semanev = NULL, $sema_xsd, $sema_namespace, $sema_format) {
  global $revmetadataFormats;
  $betoltendo_semanev = $revmetadataFormats[$sema_format]["format.name"];
  $str = XMLtagStart($betoltendo_semanev . ":" . $sema_format, array(
    "xmlns:xsi" => "http://www.w3.org/2001/XMLSchema-instance",
    "xmlns:" . $betoltendo_semanev => $sema_namespace,
    "xsi:schemaLocation" => $sema_namespace . " ". $sema_xsd));
  //$str = "<" . $betoltendo_semanev . ":" . $sema_format . " xmlns:$betoltendo_semanev=\"$sema_namespace\" xsi:schemaLocation=\"$sema_namespace $sema_xsd\">";
  while (list($kulcs, $ertek) = each($xml)) {
    while (list($key, $val) = each($xml[$kulcs])) {
      for ($i = 0; $i < sizeof($xml[$kulcs][$key]); $i++) {
        if (strlen(trim($xml[$kulcs][$key][$i])) != 0) {
          if (($kulcs != $key) && ($key !== "")) {
            $str .= XMLtag($betoltendo_semanev . ":" . $kulcs, array("qualifier" => $key), htmlspecialchars($xml[$kulcs][$key][$i]));
          } else {
            $str .= XMLtag($betoltendo_semanev . ":" . $kulcs, NULL, htmlspecialchars($xml[$kulcs][$key][$i]));
          }
        }
      }
    }
  }
  $str .= XMLtagEnd($betoltendo_semanev . ":" . $sema_format);
  //return base64_encode(gzcompress($str));
  return $str;
}

// writeRecords
// betlts sorn feldolgozott, illetve a korbbiakban mr betlttt adatokkal sszefslt j repository
// allomany adatbazisba toltese
function writeRecords($repository, $records, $repositoryIdentifier) {
  global $sema_namespace, $metadataFormats;

  $db = new transdb($repository["type"], $repository["host"], $repository["user"], $repository["password"], $repository["database"]);
  $sql = $db->delete($repository["table"], "externalid <> " . $db->escapestr(""));

  echo "<table cellpadding=2 cellspacing=0 border=1><tr><td colspan=4 align=center>Osszes OAI rekord</td></tr>";
  echo "<tr><td>kulso rekord azonosito</td><td>sema</td><td>kiosztott oai azonosito</td><td>statusz</td></tr>";
  foreach($records as $id => $value) {
    foreach($records[$id] as $semanev => $value2) {
      #$records[$id][$semanev]["id"] = $id;
      #$records[$id][$semanev]["root_name"] = $semanev;
      $db->insert($repository["table"], array(
        "id" => $db->escapestr($records[$id][$semanev]["id"]),
        "sett" => $db->escapestr($records[$id][$semanev]["sett"]),
        "created" => $db->escapedate($records[$id][$semanev]["created"]),
        "modified" => $db->escapedate($records[$id][$semanev]["modified"]),
        "deleted" => $db->escapedate($records[$id][$semanev]["deleted"]),
        "xml" => $db->escapestr($records[$id][$semanev]["xml"]),
        "harvestable" => $db->escapestr($records[$id][$semanev]["harvestable"]),
        "root_name" => $db->escapestr($records[$id][$semanev]["root_name"]),
        "root_namespace" => $db->escapestr($records[$id][$semanev]["root_namespace"]),
        "externalid" => $db->escapestr($records[$id][$semanev]["externalid"])));
      echo "<tr><td>" . $records[$id][$semanev]["externalid"] . "</td><td>" . $semanev . "</td><td>oai:" . $repositoryIdentifier . ":" . $id . "</td>";
      if ($records[$id][$semanev]["created"] != $records[$id][$semanev]["deleted"]) {
        echo "<td>deleted</td>";
      } elseif ($records[$id][$semanev]["created"] != $records[$id][$semanev]["modified"]) {
        echo "<td>modified</td>";
      } else {
        echo "<td>original</td>";
      }
      echo "<tr>";
    }
  }
  echo "</table>";

  $db->SQL_disconnect();
  return $records;
}

// feltoltott file feldolgozasa
function UploadFile($file) {
  global $config, $metadataFormats, $revmetadataFormats;
  global $repository, $mode;
  global $setneve, $sethosszunev, $setDescription;
  global $oai_dc_semanev, $oai_dc_xsd, $oai_dc_namespace, $oai_dc_format;
  global $maxid;

  $sema_format = $_REQUEST["schema"];
  $sema_xsd = $revmetadataFormats[$sema_format]["schema"];
  $sema_namespace = $revmetadataFormats[$sema_format]["namespace"];
  $sema_name = $revmetadataFormats[$sema_format]["format.name"];
  $map = $revmetadataFormats[$sema_format]["map"];
  $dcmap = $revmetadataFormats[$sema_format]["dcmap"];

  if ((file_exists($file)) && (filesize($file) > 0)) {
    $handle = fopen($file, "r");
    $sorszam = 0;
    if (isset($_REQUEST["csvheader"])) {
      $data = fgetcsv($handle, 15000, $revmetadataFormats[$sema_format]["csvseparator"], "\0");
    }
    while (($data = fgetcsv($handle, 15000, $revmetadataFormats[$sema_format]["csvseparator"], "\0")) !== FALSE) {
      if (sizeof($data) > 0) {
        $data[0] = preg_replace("/^\357\273\277/", "", $data[0]); // strip utf8 header
      }
      for ($i = 0; $i < sizeof($data); $i++) {
        $mdc[$map[$i][0]][$map[$i][1]][$map[$i][2]] = $data[$i];
        $dc[$dcmap[$i][0]][$dcmap[$i][0]][$dcmap[$i][1]] = $data[$i];
        if (($map[$i][0] == "identifier") && ($map[$i][1] == "identifier")) {
          $identifier = $data[$i];
        }
      }

      $betoltes_datuma = ISO8601Date();
      if (isset($setneve)) {
        $most_konvertalt_rekordok[$identifier][$sema_format]["sett"] = $setneve;
        #$most_konvertalt_rekordok[$identifier]["dc"]["sett"] = $setneve;
      } else {
        $most_konvertalt_rekordok[$identifier][$sema_format]["sett"] = "";
        #$most_konvertalt_rekordok[$identifier]["dc"]["sett"] = "";
      }
      $most_konvertalt_rekordok[$identifier][$sema_format]["created"] = $betoltes_datuma;
      #$most_konvertalt_rekordok[$identifier]["dc"]["created"] = $betoltes_datuma;
      $most_konvertalt_rekordok[$identifier][$sema_format]["modified"] = $betoltes_datuma;
      #$most_konvertalt_rekordok[$identifier]["dc"]["modified"] = $betoltes_datuma;
      $most_konvertalt_rekordok[$identifier][$sema_format]["deleted"] = $betoltes_datuma;
      #$most_konvertalt_rekordok[$identifier]["dc"]["deleted"] = $betoltes_datuma;
      $most_konvertalt_rekordok[$identifier][$sema_format]["xml"] = generateXML($mdc, NULL, $sema_xsd, $sema_namespace, $sema_format);
      #$most_konvertalt_rekordok[$identifier]["dc"]["xml"] = generateXML_oai_dc($dc, NULL, $oai_dc_xsd, $oai_dc_namespace, $oai_dc_format);
      $most_konvertalt_rekordok[$identifier][$sema_format]["root_name"] = $sema_format;
      #$most_konvertalt_rekordok[$identifier]["dc"]["root_name"] = $oai_dc_format;
      $most_konvertalt_rekordok[$identifier][$sema_format]["root_namespace"] = $sema_namespace;
      #$most_konvertalt_rekordok[$identifier]["dc"]["root_namespace"] = $oai_dc_namespace;
      $most_konvertalt_rekordok[$identifier][$sema_format]["externalid"] = $identifier;
      #$most_konvertalt_rekordok[$identifier]["dc"]["externalid"] = $identifier;
      if (array_key_exists("source", $dc) && is_string($dc["source"]["source"]["0"]) && (strlen($dc["source"]["source"]["0"]) > 0) &&
        !preg_match("#(http|ftp)s?://.*\..*#i", $dc["source"]["source"]["0"])) {
        $most_konvertalt_rekordok[$identifier][$sema_format]["harvestable"] = "n";
        #$most_konvertalt_rekordok[$identifier]["dc"]["harvestable"] = "n";
      } else {
        $most_konvertalt_rekordok[$identifier][$sema_format]["harvestable"] = "y";
        #$most_konvertalt_rekordok[$identifier]["dc"]["harvestable"] = "y";
      }

      $sorszam++;
    }
    fclose($handle);
  }

  // beolvassra kerl a korbbi betltsek eredmnyeknt meglvo repository tartalma
  if (($eddigi_oai_rekordok = getRecordsNew($repository, TRUE)) === FALSE) {
    print "<br />Nem tudom megnyitni az adatbzist!<br />";
    return FALSE;
  }
  // az sszefslshez, j rekordok beszrshoz szksg van a legutols azonostra
  //$maxid = getMaxIDFromCSV($repositoryfile);
  //$maxid = getMaxID($eddigi_oai_rekordok);

  if (is_array($most_konvertalt_rekordok)) {
    // az elso krben a mdosulsok kerlnek tvezetsre, illetve az j rekordok hozzadsa trtnik meg.
    echo "<table cellpadding=2 cellspacing=0 border=1><tr><td colspan=2 align=center>Most beolvasott rekordok</td></tr>";
    echo "<tr><td>rekord azonosito</td><td>sema</td></tr>";
    foreach ($most_konvertalt_rekordok as $identifier => $val1) {
      foreach ($val1 as $semanev => $value) {
        echo "<tr><td>" . $identifier . "</td><td>" . $semanev . "</td></tr>";
        if (is_array($eddigi_oai_rekordok) && array_key_exists($identifier, $eddigi_oai_rekordok)) {
          if (array_key_exists($semanev, $eddigi_oai_rekordok[$identifier])) {
            if ($most_konvertalt_rekordok[$identifier][$semanev]["xml"] != $eddigi_oai_rekordok[$identifier][$semanev]["xml"] || $most_konvertalt_rekordok[$identifier][$semanev]["sett"] != $eddigi_oai_rekordok[$identifier][$semanev]["sett"]) {
              //modosult a rekord tartalma, vagy mas halmazba sorolodott at
              $eddigi_oai_rekordok[$identifier][$semanev]["sett"] = $most_konvertalt_rekordok[$identifier][$semanev]["sett"];
              $eddigi_oai_rekordok[$identifier][$semanev]["xml"] = $most_konvertalt_rekordok[$identifier][$semanev]["xml"];
              $eddigi_oai_rekordok[$identifier][$semanev]["modified"] = $most_konvertalt_rekordok[$identifier][$semanev]["modified"];
              $eddigi_oai_rekordok[$identifier][$semanev]["deleted"] = $eddigi_oai_rekordok[$identifier][$semanev]["created"];
              $eddigi_oai_rekordok[$identifier][$semanev]["harvestable"] = $most_konvertalt_rekordok[$identifier][$semanev]["harvestable"];
              $eddigi_oai_rekordok[$identifier][$semanev]["root_name"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_name"];
              $eddigi_oai_rekordok[$identifier][$semanev]["root_namespace"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_namespace"];
              $eddigi_oai_rekordok[$identifier][$semanev]["externalid"] = $most_konvertalt_rekordok[$identifier][$semanev]["externalid"];
            } else {
            }
            if ($eddigi_oai_rekordok[$identifier][$semanev]["created"] != $eddigi_oai_rekordok[$identifier][$semanev]["deleted"]) {
              // ezek szerint korabban toroltuk, most meg megis be akarjuk rakni
              $eddigi_oai_rekordok[$identifier][$semanev]["modified"] = $most_konvertalt_rekordok[$identifier][$semanev]["modified"];
              $eddigi_oai_rekordok[$identifier][$semanev]["deleted"] = $eddigi_oai_rekordok[$identifier][$semanev]["created"];
              $eddigi_oai_rekordok[$identifier][$semanev]["harvestable"] = $most_konvertalt_rekordok[$identifier][$semanev]["harvestable"];
              $eddigi_oai_rekordok[$identifier][$semanev]["root_name"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_name"];
              $eddigi_oai_rekordok[$identifier][$semanev]["root_namespace"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_namespace"];
              $eddigi_oai_rekordok[$identifier][$semanev]["externalid"] = $most_konvertalt_rekordok[$identifier][$semanev]["externalid"];
            }
          } else {
            // az adott metaadat mar mas formatumban, mas sema szerint rendelkezesre all
            #$t = array_keys($eddigi_oai_rekordok[$identifier]);
            #$id = $eddigi_oai_rekordok[$identifier][$t[0]]["id"];

            #$eddigi_oai_rekordok[$identifier][$semanev]["id"] = $identifier; # ??! $id volt es az elozo ket kommentezett sor 'generalta'
            $maxid++;
            $eddigi_oai_rekordok[$identifier][$semanev]["id"] = $maxid;
            $eddigi_oai_rekordok[$identifier][$semanev]["sett"] = $most_konvertalt_rekordok[$identifier][$semanev]["sett"];
            $eddigi_oai_rekordok[$identifier][$semanev]["xml"] = $most_konvertalt_rekordok[$identifier][$semanev]["xml"];
            $eddigi_oai_rekordok[$identifier][$semanev]["created"] = $most_konvertalt_rekordok[$identifier][$semanev]["created"];
            $eddigi_oai_rekordok[$identifier][$semanev]["modified"] = $most_konvertalt_rekordok[$identifier][$semanev]["modified"];
            $eddigi_oai_rekordok[$identifier][$semanev]["deleted"] = $most_konvertalt_rekordok[$identifier][$semanev]["deleted"];
            $eddigi_oai_rekordok[$identifier][$semanev]["harvestable"] = $most_konvertalt_rekordok[$identifier][$semanev]["harvestable"];
            $eddigi_oai_rekordok[$identifier][$semanev]["root_name"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_name"];
            $eddigi_oai_rekordok[$identifier][$semanev]["root_namespace"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_namespace"];
            $eddigi_oai_rekordok[$identifier][$semanev]["externalid"] = $most_konvertalt_rekordok[$identifier][$semanev]["externalid"];
          }
        } else {
          // nincs meg ilyen rekord azonosito
          //$maxid++;
          //$eddigi_oai_rekordok[$identifier][$semanev]["old_id"] = $maxid;
          $maxid++;
          $eddigi_oai_rekordok[$identifier][$semanev]["id"] = $maxid;
          $eddigi_oai_rekordok[$identifier][$semanev]["sett"] = $most_konvertalt_rekordok[$identifier][$semanev]["sett"];
          $eddigi_oai_rekordok[$identifier][$semanev]["created"] = $most_konvertalt_rekordok[$identifier][$semanev]["created"];
          $eddigi_oai_rekordok[$identifier][$semanev]["modified"] = $most_konvertalt_rekordok[$identifier][$semanev]["modified"];
          $eddigi_oai_rekordok[$identifier][$semanev]["deleted"] = $most_konvertalt_rekordok[$identifier][$semanev]["deleted"];
          $eddigi_oai_rekordok[$identifier][$semanev]["xml"] = $most_konvertalt_rekordok[$identifier][$semanev]["xml"];
          $eddigi_oai_rekordok[$identifier][$semanev]["harvestable"] = $most_konvertalt_rekordok[$identifier][$semanev]["harvestable"];
          $eddigi_oai_rekordok[$identifier][$semanev]["root_name"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_name"];
          $eddigi_oai_rekordok[$identifier][$semanev]["root_namespace"] = $most_konvertalt_rekordok[$identifier][$semanev]["root_namespace"];
          $eddigi_oai_rekordok[$identifier][$semanev]["externalid"] = $most_konvertalt_rekordok[$identifier][$semanev]["externalid"];
        }
      }
    }
    echo "</table><br><br>";
  }

  if (is_array($eddigi_oai_rekordok)) {
    // torolt elemek beallitasa
    foreach ($eddigi_oai_rekordok as $identifier => $value) {
      foreach ($value as $semanev => $value2) {
        if (($semanev != "dc") && ($semanev == $sema_format)) {
          if (($mode == 0) && (is_array($most_konvertalt_rekordok))) {
            if ((array_key_exists($identifier, $most_konvertalt_rekordok)) && (array_key_exists($semanev, $most_konvertalt_rekordok[$identifier]))) {
              // vagy valtozatlan, vagy mar kijavitottuk
            } else {
              // ez a rekord torlodott
              $eddigi_oai_rekordok[$identifier][$semanev]["deleted"] = ISO8601Date();
              #$eddigi_oai_rekordok[$identifier]["dc"]["deleted"] = ISO8601Date();
            }
          }
        }
      }
    }
    // recordok osszefesulese
    foreach ($eddigi_oai_rekordok as $identifier => $value) {
      foreach ($value as $semanev => $value2) {
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["id"] = $eddigi_oai_rekordok[$identifier][$semanev]["id"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["sett"] = $eddigi_oai_rekordok[$identifier][$semanev]["sett"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["created"] = $eddigi_oai_rekordok[$identifier][$semanev]["created"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["modified"] = $eddigi_oai_rekordok[$identifier][$semanev]["modified"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["deleted"] = $eddigi_oai_rekordok[$identifier][$semanev]["deleted"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["xml"] = $eddigi_oai_rekordok[$identifier][$semanev]["xml"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["harvestable"] = $eddigi_oai_rekordok[$identifier][$semanev]["harvestable"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["root_name"] = $eddigi_oai_rekordok[$identifier][$semanev]["root_name"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["root_namespace"] = $eddigi_oai_rekordok[$identifier][$semanev]["root_namespace"];
        $records[$eddigi_oai_rekordok[$identifier][$semanev]["id"]][$semanev]["externalid"] = $eddigi_oai_rekordok[$identifier][$semanev]["externalid"];
      }
    }
  }
  // ha res az llomny s nem tltnk be semmit, akkor nem kell semmit sem csinlni
  if (is_array($records)) {
    // az sszefslt tmbt a rekordid-re rendezzk
    ksort($records);
    /* // nem hatarozzuk meg, mert nem lesz ra szuksegunk sehol!!
    // meghatrozzuk a legkorbbi rekord dtumt. ez az rtk ksobb bekerl a header-be
    $min = ISO8601Date();
    $setek = array();
    while (list($id, $value) = each($records)) {
      while (list ($semanev, $value2) = each($records[$id])) {
        if ($records[$id][$semanev]["created"] < $min) {
          $min = $records[$id][$semanev]["created"];
        }
      }
    }
    */
    // a korbbi header-t betltjk
    #$header = getHeaderFromCSV();
    // a mr hasznlt smk listjt elolltjuk
    //$semak = unserialize(base64_decode($header[1]));
    // a mr hasznlt halmazok listjt elolltjuk
    #$setek = unserialize(base64_decode($header[2]));
    // szksg esetn hozzadjuk a mostani halmazt
    #$setek[$setneve]=array($sethosszunev, $setDescription);
    // szksg esetn hozzadjuk a listhoz a mostani betltsnl hasznlt smt.
    //$semak[$betoltendo_semanev]=array($sema_xsd, $sema_namespace);
    //$semak[$oai_dc_semanev]=array($oai_dc_xsd, $oai_dc_namespace);
    // kirjuk a headert s a rekordokat, egyszval a repository llomnyt
    //writeRecordsToCSV($repositoryfile, $records, $min, $setek, $semak, $repositoryIdentifier);
    writeRecords($repository, $records, $config["repositoryId"]);
  }
  return TRUE;
}

// megnezzuk, hogy feltoltott-e a user valamit es sikeres volt-e a foltoltes, ha igen, atmozgatjuk a feltoltott tmp file-t
// egy altalunk elerheto helyre (sajat directory-ba) - safe_mode restrictions miatt csinaljuk igy (Closes: #000001 ;)))
// ha ez mind sikerult, akkor feldolgozzuk -> UploadFile
function main() {
  PrintHeader();
  $file = "";
  if (is_array($_FILES) && isset($_FILES["userfile"]["tmp_name"]) && is_uploaded_file($_FILES["userfile"]["tmp_name"])) {
    $file = tempnam("./", "tmp_file.");
    if (! move_uploaded_file($_FILES["userfile"]["tmp_name"], $file)) {
      $file = "";
    }
    if (file_exists($file)) {
      if (UploadFile($file)) {
        triggerHarvester();
      }
      unlink($file);
    } else {
      print "Nem tudtam feldolgozni a feltoltott file-t (" . $_FILES[userfile][name] . ")<br />\n";
    }
  }
  PrintForm();
  PrintFooter();
}

?>
